#include <iostream>
#include <vector>
#include <string>
using namespace std;

int main () {
    vector<string> inscriptions;
    vector<float> numbers;
    vector<size_t> baskets;
    size_t numbers_count;
    size_t baskets_count;
    size_t baskets_max_count;
    const size_t screen_width = 80;
    const size_t max_asterisk = screen_width - 3 - 1;
    float basket_max;
    float basket_min;
    float basket_size;
    cout.precision(4);
    
    cerr << "Введите кол-во чисел в строке: ";
    cin >> numbers_count;
    numbers.resize(numbers_count);
    
    cerr << "Введите строку чисел: ";
    for (float& i : numbers) {
        cin >> i;
    }
    
    cerr << "Введите кол-во корзин: ";
    cin >> baskets_count;
    
    baskets.resize(baskets_count);
    inscriptions.resize(baskets_count);
    
    cerr << "Введите подписи к столбцам:" << endl;
    for (string& i : inscriptions) {
        cin >> i;
    }
    
    basket_max = numbers[0];
    for (int i : numbers) {
        if (i > basket_max) basket_max = i;
    }
    basket_min = numbers[0];
    for (int i : numbers) {
        if (i < basket_min) basket_min = i;
    }
    
    basket_size = (basket_max - basket_min) / baskets_count;
    
    for (int i = 0; i < baskets_count; i++) {
        for (int j = 0; j < numbers_count; j++) {
            if ((numbers[j] >= (basket_min + i * basket_size) and numbers[j] < (basket_min + (i + 1) * basket_size)) or (i == baskets_count - 1 and numbers[j] == basket_max)) {
                baskets[i]++;
            }
        }
    }
    
    baskets_max_count = baskets[0];
    for (size_t i : baskets) {
        if (i > baskets_max_count) baskets_max_count = i;
    }
    
    for (int i = 0; i < baskets_count; i++) {
        size_t height = baskets[0];
        if (baskets_max_count > max_asterisk) {
            height = max_asterisk * (static_cast<double>(baskets[i]) / baskets_max_count);
        }
        cout << inscriptions[i] << "|";
        for (int j = 0; j < height; j++) cout << "*";
        cout << endl;
    }
    return 0;
}

